% only mode == 1 currently works
function [x2, logpo2] = metropolis(xparam1, vv, gend, data, mh_bounds, filename, ...
			 mode, x2, logpo2)

global bayestopt_ exo_nbr dr_ estim_params_ Sigma_e_ options_ xparam_test
global lgy_ lgx_


if mode == 0; % normal mode
    d=chol(vv);
    npar = length(xparam1);
    % Metropolis-Hastings algorithm for posterior distribution
    %par0 = rndprior(bayestopt_);
    par0 = xparam1';
    h = waitbar(0,'Please wait...');
    options_.lik_algo = 1;
    nruns = options_.mh_replic;
    x2=zeros(nruns,npar);
    logpo2=zeros(nruns,1);
    logpo2(1) = -mj_optmumlik(xparam1,gend,data,1);
    x2(1,:) = xparam1';
    isux = 0;
    for j = 2: nruns;
        % jumping function
        par = randn(1, npar) * d;
        par = par.*bayestopt_.jscale' + x2(j-1,:);  
        if all(par' > mh_bounds(:,1)) & all(par' < mh_bounds(:,2));
            logpost = -mj_optmumlik(par',gend,data,1);
        else;
            logpost = -inf;
        end;    
        if  logpost>-inf & rand<exp(logpost - logpost0);
            isux = isux+1;
            x2(j,:) = par;
            logpo2(j,1) = logpost;
            waitbar(j/nruns,h,['Please wait... success rate ',num2str(isux),'/',num2str(j)]);
        else    
            x2(j,:) = par0;
            logpo2(j,1) = logpo2(j-1,1);
            post2(j,1) = post2(j-1,1);
        end    
        par0 = x2(j,:);
        logpost0=logpo2(j, 1);
    end
    close(h)
    save(filename,'x2','logpo2','post2')
elseif mode == -1; % interactive mode.
    global mh_exit_
    mh_exit_ = 0;
    d=chol(vv);
    npar = length(xparam1);
    % Metropolis-Hastings algorithm for posterior distribution
    par0 = xparam1';
    h1 = waitbar(0,'Please wait...');
    options_.lik_algo = 1;
    nruns = options_.mh_replic;
    x2=zeros(nruns,npar);
    logpo2=zeros(nruns,1);
    post2=logpo2;
    logpost0 = -mj_optmumlik(par0',gend,data,1); %-FVAL;
    logpo2(1) = logpost0;
    post2(1) = exp(logpo2(1));
    x2(1,:) = par0;
    isux = 0;
    h2 = figure('Name','Metropolis Hastings algorithm...','WindowButtonDownFcn',@myCallback);
    plt1 = plot(0,par0*ones(npar,1),'.r');
    set(plt1,'EraseMode','none');
    hold on;
    xxx = par0*ones(npar,1);
    plt2  = plot(0,xxx,'.b');
    axis([0 nruns-1 0.97*xxx 1.03*xxx]);
    set(plt2,'EraseMode','none');
    for j = 2: nruns,
        if mh_exit_ == 1;
            nruns  = j-1;
            x2     = x2(1:nruns,:); 
            logpo2 = logpo2(1:nruns,1);
            post2  = post2(1:nruns,1);
            save(filename,'x2','logpo2','post2');
            close(h2);
            close(h1); % TODO refaire le graphique (h2)  partir de x2... 
            return
        end 
        % jumping function
        par = randn(1, npar) * d;
        par = par.*bayestopt_.jscale' + par0;  
        if all(par' > mh_bounds(:,1)) & all(par' < mh_bounds(:,2));
            logpost = -mj_optmumlik(par',gend,data,1);
        else;
            logpost = -inf;
        end;    
        if rand < exp(logpost - logpost0);
            isux = isux+1;
            x2(j,:) = par;
            logpo2(j,1) = logpost;
            post2(j,1) = exp(logpost);
            waitbar(j/nruns,h1,['Metropolis-Hastings success rate is ',num2str(isux/j)]);
        else    
            x2(j,:) = par0;
            logpo2(j,1) = logpo2(j-1,1);
            post2(j,1) = post2(j-1,1);
        end    
        par0 = x2(j,:);
        logpost0=logpo2(j, 1);
        %% diagnostic plot for convergence
        set(plt2,'XData',j-1,'YData',mean(x2(1:j,:))*ones(npar,1));
        if j>1000;% moving average...
            set(plt1,'XData',j-1,'YData',mean(x2(j-1000:j,:))*ones(npar,1));  
        end;
        drawnow;
    end;
    save(filename,'x2','logpo2','post2');
    close(h1);
    close(h2);
elseif mode == 1;% parallel mode
    nruns = options_.mh_replic;
    nblck = options_.mh_nblck;    
    npar  = length(xparam1);
    d = chol(vv);
    options_.lik_algo = 1;
    x3 = zeros(nblck*nruns,npar);
    n_rejected = 1;
    %    bound_lik = -mj_optmumlik(xparam1,gend,data,1)-log(10);
    if isempty(x2)
      x2 = zeros(nruns,npar,nblck);
      logpo2 = zeros(nruns,nblck);
      disp('MH: searching for initial values');
      for j=1:nblck  % I'm choosing good initial conditions for Markov
		     % chains...
         validate = 0;
	 init_iter = 0;
	 while validate == 0
	   candidate = options_.mh_init_scale*randn(1,npar)*d + xparam1';
	   
	   if all(candidate' > mh_bounds(:,1)) & ...
		 all(candidate' < mh_bounds(:,2)) 
	     %	    & -mj_optmumlik(candidate',gend,data,1) > bound_lik;
	     x2(1,:,j) = candidate;
	     j = j+1;
	     validate = 1;
	   end
	   init_iter = init_iter + 1;
	   if init_iter > 100 & validate == 0
	     error(['MH couldn''t get a valid initial value in 100 trials.' ...
		    ' Reduce mh_init_scale.'])
	   end
	 end
      end
      jj = 1;
      for b=1:nblck
        logpo2(1,b) = -mj_optmumlik(x2(jj,:,b)',gend,data,1);
      end
      disp('MH: initial values found')
    else
      jj = size(x2,1)
      x2 = [x2; zeros(nruns,npar,nblck)];
      logpo2 = [logpo2; zeros(nruns,nblck)];
    end

    h2 = waitbar(0,'Please wait... Metropolis-Hastings...');
    isux = zeros(nblck,1);
    for j=jj+1:jj+nruns;
        for b = 1:nblck;
            par = randn(1, npar) * d;
            par = par.*bayestopt_.jscale' + x2(j-1,:,b);  
            if all(par' > mh_bounds(:,1)) & all(par' < mh_bounds(:,2));
                logpost = -mj_optmumlik(par',gend,data,1);
            else;
                logpost = -inf;
            end;    
            if logpost > -inf & log(rand) < logpost - logpo2(j-1,b);
                x2(j,:,b) = par;
                logpo2(j,b) = logpost;
                isux(b) = isux(b)+1;
            else    
                x2(j,:,b) = x2(j-1,:,b);
		x3(n_rejected,:) = par;
                logpo2(j,b) = logpo2(j-1,b);
		n_rejected = n_rejected + 1;
            end
        end;    
	i1 = (j-jj)/nruns;
	waitbar(i1,h2,sprintf('%f done, acceptation rate %f',i1,mean(isux)/(j-jj)));
    end;
    close(h2);
    disp('Acceptation rates :');
    for b=1:nblck;
        accept = isux(b)/nruns;
	disp(sprintf('Block %d: %f',b,accept))
    end;    
    post2 = exp(logpo2);
    x3 = x3(1:n_rejected-1,:);
    save(filename,'x2','logpo2','post2','x3');
    disp('MH: end of algorithm')
end;


function myCallback(obj,eventdata)
global mh_exit_
mh_exit_ = 1;
    
    
    
% 12/01/03 MJ adapted from M. Ratto's version
% 12/21/03 SA added "mode = -1" (convergence plot diagnostic).
% 12/31/03 SA added "mode =  1" (parallel MCMC implementation).
 