function mode_check(x,fval,hessian,gend,data,lb,ub)
  global bayestopt_
  
%  hh1 = inv(hessian);

  [s_min,k] = min(diag(hessian))
  if s_min > 0
%    return
  end
  
  disp('\nMODE CHECK\n')
  disp(sprintf('Fval obtained by fmincon: %f', fval))
  disp(bayestopt_.name)
  cname = bayestopt_.name{k};
  disp(sprintf('Most negative variance %f for parameter %d (%s = %f)',s_min,k,cname,x(k)))
  figure
  for k=1:length(x)
    subplot(7,5,k);
    cname = bayestopt_.name{k};
    xx = x;
    l1 = max(lb(k),0.8*x(k));
    l2 = min(ub(k),1.2*x(k));
    z = [l1:(l2-l1)/20:l2];
    y = zeros(length(z),1);
    for i=1:length(z)
      xx(k) = z(i);
      y(i) = mj_optmumlik(xx,gend,data,1);
    end
    
    plot(z,y);
    hold on;
    yl=get(gca,'ylim');
    plot( [x(k) x(k)], yl, 'c', 'LineWidth', 1)
    title(cname,'interpreter','none');
  end
